
-- PERF_MOVIMENTO_CONTABILE
SELECT  GPM.ID_PROGRAMMA_MUSICALE,
	PM.NUMERO AS NUMERO_PM,
	GPM.ID_EVENTO,	
	VPQ.ID_TIPO_MODELLO AS TIPOLOGIA_MOVIMENTO,
	GPM.IMPORTO_DDA AS IMPORTO_MANUALE,
	PME.COD_VOCE_INCASSO AS CODICE_VOCE_INCASSO,	
	PM.PROG_PROTOC_PERMESSO AS NUMERO_PERMESSO,
	VPQ.IMPORTO AS TOTALE_DEM_LORDO_PM,
	VPQ.REVERSALE AS NUMERO_REVERSALE,
	PME.FLAG_GRUPPO_PRINCIPALE AS FLAG_GRUPPO_PRINCIPALE,
	Q.NUM_FATTURA AS NUMERO_FATTURA,
	VPQ.IMPORTO AS IMPORTO_DEM_TOTALE,
  	NVL(GPE.ATTESI,0) AS NUMERO_PM_PREVISTI,
  	--NVL(GPE.ATTESI,0) - NVL(GPE.GRUPPOPRINCIPALE,0) AS NUMERO_PM_PREVISTI_SPALLA,
        CASE WHEN GPM.COD_VOCE_INCASSO='2244' THEN (NVL(GPE.ATTESI,0) - NVL(GPE.GRUPPOPRINCIPALE,0)) ELSE 0 END AS NUMERO_PM_PREVISTI_SPALLA,  
	VPQ.DATA AS DATA_REVERSALE,
  	PM.DATA_RESTITUZIONE,
CASE WHEN Q.DATA>=PM.DATA_RESTITUZIONE THEN TO_CHAR(Q.DATA,'YYYYMM') ELSE TO_CHAR(PM.DATA_RESTITUZIONE,'YYYYMM') END AS CONTABILITA
FROM PROGRAMMA_MUSICALE PM 
JOIN PROGRAMMA_MUSICALE_EVENTO PME ON PME.ID_PROGRAMMA_MUSICALE = PM.ID_PROGRAMMA_MUSICALE
JOIN GESTIONE_PM GPM ON GPM.ID_PROGRAMMA_MUSICALE=PM.ID_PROGRAMMA_MUSICALE
JOIN VIEW_PMO_QUIETANZE VPQ ON VPQ.ID_QUIETANZA = GPM.ID_QUIETANZA AND VPQ.ID_EVENTO = PME.ID_EVENTO AND VPQ.COD_VOCE_INCASSO = PME.COD_VOCE_INCASSO
JOIN QUIETANZA Q ON Q.ID_QUIETANZA = GPM.ID_QUIETANZA
LEFT JOIN GPM_EVENTO GPE ON GPE.ID_EVENTO=PME.ID_EVENTO AND PME.COD_VOCE_INCASSO = GPE.COD_VOCE_INCASSO
WHERE PM.STATO='V'
AND PM.DATA_158 IS NOT NULL
AND GPM.STATO=1
AND GPM.ID_QUIETANZA IS NOT NULL
AND TRUNC(GPM.DATA_158,'MONTH')=TO_DATE('2017-01','YYYY-MM')


-- PERF_UTILIZZAZIONE   
SELECT ID_PROGRAMMA_MUSICALE,
       NUMERO_PROGRAMMA_MUSICALE,
       CASE WHEN INSTR(CODICE_OPERA,'HIT')=0 THEN NVL(CODICE_OPERA,'-') ELSE null END AS CODICE_OPERA,
       NVL(TITOLO_COMPOSIZIONE,'-') AS TITOLO_COMPOSIZIONE,
       NVL(COMPOSITORE,'-') AS COMPOSITORE,
       DURATA,
       DURATA_INFERIORE_60SEC       
 FROM (
  (SELECT PM_QUADRO_D.ID_PROGRAMMA_MUSICALE AS ID_PROGRAMMA_MUSICALE,
              PROGRAMMA.NUMERO AS NUMERO_PROGRAMMA_MUSICALE,
              CODICE_OPERA,
              TITOLO AS TITOLO_COMPOSIZIONE,
                      COALESCE (COMPOSITORE,SUBSTR(ELENCO_COMPOSITORI,1,DECODE(INSTR(ELENCO_COMPOSITORI,','),0,300,INSTR(ELENCO_COMPOSITORI,',')-1)),
                      SUBSTR(ELENCO_AUTORI,1,DECODE(INSTR(ELENCO_AUTORI,','),0,300,INSTR(ELENCO_AUTORI,',')-1)),
                      substr(ELENCO_INTERPRETI,1,decode(INSTR(ELENCO_INTERPRETI,','),0,300,INSTR(ELENCO_INTERPRETI,',')-1))) AS COMPOSITORE,
              (SUBSTR(DURATA_ESECUZIONE,1, INSTR(DURATA_ESECUZIONE,':')-1  ) * 60 ) + SUBSTR(DURATA_ESECUZIONE,INSTR(DURATA_ESECUZIONE,':')+1, LENGTH (DURATA_ESECUZIONE)) AS DURATA,
              TO_NUMBER (NVL (DURATA_ESEC_INFERIORE_A, 0)) AS DURATA_INFERIORE_60SEC,
              ID_PM_QUADRO_D
         FROM PM_QUADRO_D PM_QUADRO_D
              JOIN PROGRAMMA_MUSICALE PROGRAMMA ON PM_QUADRO_D.ID_PROGRAMMA_MUSICALE=PROGRAMMA.ID_PROGRAMMA_MUSICALE   
        WHERE PROGRAMMA.STATO='V' 
          AND TRUNC(PROGRAMMA.DATA_158,'MONTH') = TO_DATE('2017-01','YYYY-MM')
          AND PROGRAMMA.COD_VOCE_INCASSO ='2224'
  )
  UNION               
(
  SELECT PM_QUADRO_D.ID_PROGRAMMA_MUSICALE AS ID_PROGRAMMA_MUSICALE,
              PROGRAMMA.NUMERO AS NUMERO_PROGRAMMA_MUSICALE,
              CODICE_OPERA,
              TITOLO AS TITOLO_COMPOSIZIONE,
                      COALESCE (COMPOSITORE,substr(ELENCO_COMPOSITORI,1,decode(INSTR(ELENCO_COMPOSITORI,','),0,300,INSTR(ELENCO_COMPOSITORI,',')-1)),
                      SUBSTR(ELENCO_AUTORI,1,DECODE(INSTR(ELENCO_AUTORI,','),0,300,INSTR(ELENCO_AUTORI,',')-1)),
                      substr(ELENCO_INTERPRETI,1,decode(INSTR(ELENCO_INTERPRETI,','),0,300,INSTR(ELENCO_INTERPRETI,',')-1))) AS COMPOSITORE,
              (substr(durata_esecuzione,1, instr(durata_esecuzione,':')-1  ) * 60 ) + SUBSTR(DURATA_ESECUZIONE,INSTR(DURATA_ESECUZIONE,':')+1, LENGTH (DURATA_ESECUZIONE)) AS DURATA,
              TO_NUMBER (NVL (DURATA_ESEC_INFERIORE_A, 0)) AS DURATA_INFERIORE_60SEC,
              min(ID_PM_QUADRO_D)
         FROM PM_QUADRO_D PM_QUADRO_D
              JOIN PROGRAMMA_MUSICALE PROGRAMMA ON PM_QUADRO_D.ID_PROGRAMMA_MUSICALE=PROGRAMMA.ID_PROGRAMMA_MUSICALE   
        WHERE PROGRAMMA.STATO='V' 
          AND TRUNC(PROGRAMMA.DATA_158,'MONTH') = TO_DATE('2017-01','YYYY-MM')
          AND PROGRAMMA.COD_VOCE_INCASSO !='2224'
  GROUP BY PM_QUADRO_D.ID_PROGRAMMA_MUSICALE,
                PROGRAMMA.NUMERO,
                      COALESCE (COMPOSITORE,substr(ELENCO_COMPOSITORI,1,decode(INSTR(ELENCO_COMPOSITORI,','),0,300,INSTR(ELENCO_COMPOSITORI,',')-1)),
                      substr(ELENCO_AUTORI,1,decode(INSTR(ELENCO_AUTORI,','),0,300,INSTR(ELENCO_AUTORI,',')-1)),
                      substr(ELENCO_INTERPRETI,1,decode(INSTR(ELENCO_INTERPRETI,','),0,300,INSTR(ELENCO_INTERPRETI,',')-1))),
                TITOLO,
                TO_NUMBER (NVL (DURATA_ESEC_INFERIORE_A, 0)),
                    (substr(durata_esecuzione,1, instr(durata_esecuzione,':')-1  ) * 60 ) + 
                         SUBSTR(DURATA_ESECUZIONE,INSTR(DURATA_ESECUZIONE,':')+1, LENGTH (DURATA_ESECUZIONE)) ,
                CODICE_OPERA
                )
);

